-- Create table
create global temporary table YPREFORMSLP
(
  dummy  VARCHAR2(1),
  rntmp  NUMBER(17),
  authid VARCHAR2(30)
)
on commit preserve rows;

grant select, update, insert, delete on YPREFORMSLP to public;
/


CREATE OR REPLACE PROCEDURE P_YPSLPSHEET_REFORMING(nident in number)
as
   nIdent1 number(17);
   nRes    number(17);
begin

     for rec in (select s.*
                 from v_slpsheets s,
                      selectlist sl
                 where s.nrn = sl.document
                   and sl.ident = nident
                   and s.ncalcbetwn = 0)
     loop

         begin
         delete from YPREFORMSLP;

         --  
         for rec1 in (Select * from  V_SLPSHEETSPFM where NPRN= rec.nrn)
         loop
              insert into ypreformslp(rntmp,authid)
              values(rec1.nclnpspfm, user);
         end loop;

         parus.P_SLPSHEETS_BASE_CLEAR(rec.ncompany, rec.nrn);

         --   

         parus.P_SLCALCWAGES_SETCALC(rec.ncompany, rec.sslcalculat, rec.nyear, rec.nmonthnumb);

         nIdent1 := parus.GEN_IDENT;
          -- YPREFORMSLP
         for rec2 in (select T.RNTMP
                      from  YPREFORMSLP T)
         loop
             insert into parus.SELECTLIST(RN, IDENT, DOCUMENT, AUTHID)
               values(gen_id, nIdent1, rec2.RNTMP, user);
         end loop;

          PARUS.P_SLPSHEETS_FORMING(rec.ncompany, nIdent1, rec.nrn, nRes);

          delete parus.SELECTLIST SL
          where SL.IDENT = nident1;
          commit;
--          exception
--          when OTHERS then
--             p_exception(0,sqlerrm);

          end;

     end loop;

end;
/
grant execute on P_YPSLPSHEET_REFORMING to public;
